require "con-troll.lua"
require "trolls.lua"
require "trollpics.lua"
require "trollfilter.lua"
require "camera.lua"
require "gui.lua"
require "menu.lua"
require "options.lua"
require "tilemech.lua"
require "tiles.lua"
require "tilefilter.lua"
require "maps.lua"
require "jump-troll.lua"
require "phy-troll.lua"
require "fans.lua"
require "fan_filter.lua"
require "cam_move.lua"
require "bubble.lua"
require "drawmap.lua"




function love.load()
	
	
	--Animations--
	animtimer = 0
	--          --
	
	--Fonts--
	small = love.graphics.newFont("fonts/arcade.ttf", 24)
	medium = love.graphics.newFont("fonts/arcade.ttf", 35)
	large = love.graphics.newFont("fonts/arcade.ttf", 54)
	giant = love.graphics.newFont("fonts/arcade.ttf",90)
	
	--Maps--
	map = testing
	TileW = 16
	TileH = 16
	load_map = false
	draw_map()
	--    --


	--Gamestate--
	gamestate = "menu"
	--         --


	
	--characters--
	chosen = nil
	--          --
	
	--Mech--
	controlls = true
	menu_load = true
	draw_load = false
	grounded = false
	jump_tim = 0
	jumping = false
	draw_but = false
	op = false
	--    --
	
	--Keys--
	jump_key = "w"	
	int_key = "lshift"
	--    --
	
	--Colors--
	chosenred = 255
	chosenblue = 255
	chosengreen = 255
	bgred = 120
	bggreen = 120
	bgblue = 120
	love.graphics.setBackgroundColor(bgred,bggreen,bgblue)
	--      --
	
	--Gui--
	arrowright = true
	highnumb = 1
	arrowleft = true
	choose_update = false
	highname = {"Trey William Johnson","CassemG","Smosch","Soul Ging"}
	highplay = {trey.pic,cassem.pic,ian.pic,ging.pic}
	--   --
	
end
function love.update(dt)
	--Menu--
	if gamestate == "menu" or gamestate == "chooseplayer" then
		mech_menu()
		mech_choose()
	end
	
	if gamestate == "options" or gamestate == "control" or op == true then
		draw_options()
	end


	--maps--
	if gamestate == "playing" then
		chosen = highlightedp
		camera_map()
		mech_fan()
		limit_map()
		controll_player(dt, chosen)
		apply_grav(dt, chosen)
		troll_jump(dt)

	end

end
function love.draw()
	camera:set()
	--Menu--
	if gamestate == "menu" or gamestate == "chooseplayer" or gamestate == "options" or draw_but == true then
		draw_button()
	end
	if gamestate == "menu" or gamestate == "chooseplayer" then
		camera.scaleY = 1
		camera.scaleX = 1
	end
	if gamestate == "chooseplayer" then
		choose_draw()
	end
	
	
	if gamestate == "playing" then
		chosen = highlightedp
		love.graphics.setColor(255,255,255)
		draw_fan()

		love.graphics.setColor(chosenred,chosengreen,chosenblue)
		love.graphics.draw(chosen.pic, chosen.x, chosen.y)
	end
	if gamestate == "playing" then
		draw_solid()
	end
	
	
	
	
	
	
	
	
	camera:unset()
end

function love.keyreleased(key)
	if gamestate == "playing" then
		if key == "d" then
			chosen.pic = chosen.R[1]
		end
		if key == "a" then
			chosen.pic = chosen.L[1]
		end
		if key == jump_key then
			jump_tim = 0
		end
		fan_talk(key)
	end
end
function love.mousepressed(x,y)
	checkarrow(x,y)
	for i,v in ipairs(buttons) do
		if x > v.x and
		x < v.x + v.width and
		y > v.y and
		y < v.y + v.height then
			--I know, it would be easier to give each button an ID. Get off my fucking nuts.
			if v.text == "Start" then
				gamestate = "chooseplayer"
			end
			if v.text == "Options" and
			gamestate == "menu" then
				gamestate = "options"
			end
			--Backs--
			if v.text == "back" and
			gamestate == "chooseplayer" then
				menu_load = true
				gamestate = "menu"
			end
			if v.text == "back" and
			gamestate == "options" then
				menu_load = true
				gamestate = "menu"
			end
			if v.text == "back" and
			gamestate == "control" then
				gamestate = "options"
			end
			if v.text == "back" and
			gamestate == "chjump" then
				gamestate = "control"
			end
			--     -- 
			if v.text == "Quit" then
				love.event.push("q")
			end
			if v.text == "select" then
				clear_buttons()
				gamestate = "playing"
				spawn_fan(50,64,1)
				camera.scaleX = 0.2
				camera.scaleY = 0.2
				camera.x = 0
				camera.y = 0
				love.graphics.setBackgroundColor(210,233,255)
			end
			--Options--
			if v.text == "ConTrolls" and
			gamestate == "options" then
				gamestate = "control"
			end
			--       --
			--Controlls--
			if v.text == "jump" then
				op = true
				gamestate = "chjump"
			end
		end
	end
end